%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    fdSY_mat.m
%                   Russell Luke
%               Department of MathSci
%              University of Delaware  
%                  April 12, 2008 
%
%
%
%
% DESCRIPTION:  TO DO
% 
%  finite difference history ordering for limited memory matrix secant
%  methods
%
% INPUT:
%     K, mem:  dimension of incoming arrays
%     x_mat, the matrix of iterates
%     gradf_mat, the matrix of gradients
%
% OUTPUT:
%        
%     S_mat, Y_mat
%
% USAGE: 
%
%       [S_mat,Y_mat] = fdSY_mat(K,mem,x_mat,gradf_mat)
% 
% SUBROUTINE CALLS:
%      einen.m
%      

function [S_mat,Y_mat] = fdSY_mat(K,mem,x_mat,gradf_mat)

tmp_vec = einen(1,mem-1,x_mat(1,1:mem-1));
tmp_mat = x_mat(1:K,mem)*tmp_vec;
S_mat   = x_mat(1:K,1:mem-1)- tmp_mat;
tmp_mat = gradf_mat(1:K,mem)*tmp_vec;
Y_mat   = gradf_mat(1:K,1:mem-1) - tmp_mat;
