%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% prepare diagnostic data and return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[fid,message]=fopen('state.dat','r');
if (fid<0)
    disp(message)
else
    state_vec=fread(fid,[1,4*(Maxit+1)+11],'real*8');
    fclose(fid);
end
f_vec = state_vec(1:Maxit+1);
ngradf_vec = state_vec(Maxit+2:2*(Maxit+1));
stepsize_vec = state_vec(2*Maxit+3:3*(Maxit+1));
mu_vec = state_vec(3*Maxit+4:4*(Maxit+1));
iter = state_vec(4*(Maxit+1)+1);
fcounter = state_vec(4*(Maxit+1)+10);

%%%%%%%%%%%%%%%%%%%%%
% Plot Diagnostics
%%%%%%%%%%%%%%%%%%%%%

figure(1)
subplot(2,2,1),semilogy(1:iter,f_vec(1:iter)),...
    title('Function value'),...
    xlabel('iterations'),ylabel('f(x)')
subplot(2,2,2),semilogy(1:iter,ngradf_vec(1:iter));
subplot(2,2,2),title('gradient norm'),...
    xlabel('iteration'),ylabel('log(gradient norm)');
subplot(2,2,3),semilogy(1:iter,stepsize_vec(1:iter)),...
    title('stepsize'),...
    xlabel('iterations'),ylabel('||x_{k+1}-x_k||')

% to see your solution:
figure(2)
temp=feval('reshape',xnew_vec,dim(1),2*dim(2));
xnew_mat=zeros(dim(1),dim(2),2);
xnew_mat(:,:,1)=temp(:,1:dim(2));
xnew_mat(:,:,2)=temp(:,dim(2)+1:2*dim(2));
subplot(1,2,1), imagesc(xnew_mat(:,:,1)), colorbar, title('real part of recovered wavefront')
subplot(1,2,2), imagesc(xnew_mat(:,:,2)), colorbar, title('imaginary part of recovered wavefront')


