from numpy import amax, sqrt
from numpy.fft import fftshift, fft, fft2, ifft, ifft2


def FFT(f):
    dim = f.shape
    res = amax(dim)

    if len(dim) == 2:
        F = fft2(f)
        F = F/res
        F[1:res:2, :] *= -1
        F[:, 1:res:2] *= -1
    else:
        F = fft(f)
        F[1:res:2] *= -1
        F = F/sqrt(res)

    F = fftshift(F)
    return F


def IFFT(F):
    dim = F.shape
    res = amax(dim)
    F = fftshift(F)

    if len(dim) == 2:
        F[1:res:2, :] *= -1
        F[:, 1:res:2] *= -1
        F = res*F
        f = ifft2(F)
    else:
        F[1:res:2] *= -1
        F = sqrt(res)*F
        f = ifft(F)

    return f
